# FIXME: Use udev sooner or later...

%define     nvidialibdir      %{_libdir}/nvidia
%define     nvidialibdir32bit %{_prefix}/lib/nvidia

Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>

Summary: 	Nvidia legacy display driver and OpenGL libraries
Name: 		xorg-x11-drv-nvidia-legacy
Version: 	1.0.718608
Release: 	1
Group: 		System/Configuration/Hardware
License: 	Distributable
URL:        	http://www.nvidia.com/
Source0:       	http://download.nvidia.com/XFree86/Linux-x86/1.0-7184/NVIDIA-Linux-x86-71.86.04-pkg1.run
#Source1:       	http://download.nvidia.com/XFree86/Linux-x86_64/1.0-7184/NVIDIA-Linux-x86_64-71.86.01-pkg2.run
Source2:    	nvidia-glx.sh
Source3:    	nvidia-glx.csh
Source4:    	nvidia-settings.desktop
#Source11:   	nvidia-README.Fedora
Source12:   	nvidia-glx.opts

Provides:   	nvidia-legacy-kmod-common = %{version}

Conflicts:     	xorg-x11-drv-nvidia
Conflicts:     	xorg-x11-drv-fglrx

Requires:   	kmod-nvidia-legacy >= %{version}
Requires(post):  kmod-nvidia-legacy >= %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686

%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia legacy GPUs.

%package devel
Summary:    Nvidia OpenGL Headers
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description devel
This package provides the Nvidia OpenGL headers and libraries required
for development.

%postun -p /sbin/ldconfig

%post -p /sbin/ldconfig

%prep
%setup -q -c -T
sh %{SOURCE0} --extract-only --target nvidiapkg-x86
#sh %{SOURCE1} --extract-only --target nvidiapkg-x64
#tar -cvjf nvidia-glx-kmod-data-1.0.8178.tar.bz2 nvidiapkg-*/LICENSE nvidiapkg-*/usr/src/
#%ifarch %{ix86}
ln -s nvidiapkg-x86 nvidiapkg
#%else
#ln -s nvidiapkg-x64 nvidiapkg
#%endif
mv nvidiapkg/LICENSE nvidiapkg/usr/share/doc/
# More docs
#cp %{SOURCE11} nvidiapkg/usr/share/doc/README.Fedora
find nvidiapkg/usr/share/doc/ -type f | xargs chmod 0644


%install
rm -rf $RPM_BUILD_ROOT

set +x
for file in $(cd nvidiapkg &> /dev/null; find . -type f | grep -v -e 'makeself.sh$' -e 'mkprecompiled$' -e 'tls_test$' -e 'tls_test_dso.so$' -e 'nvidia-settings.desktop$' -e '^./Makefile'  -e '^./nvidia-installer' -e '^./pkg-history.txt' -e '^./.manifest' -e '/usr/share/doc/' -e 'libGL.la$' -e 'drivers/nvidia_drv.o$' -e 'nvidia-installer.1.gz$' -e '^./usr/src/')
do
  if [[ ! "/${file##./usr/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/lib/}
  elif [[ ! "/${file##./usr/X11R6/lib/modules/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/nvidia/${file##./usr/X11R6/lib/modules/extensions}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_includedir}/nvidia/${file##./usr/include/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    if [[ ! "/${file##./usr/bin/nvidia-xconfig}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/sbin/${file##./usr/bin/}
    elif [[ ! "/${file##./usr/bin/nvidia-bug-report.sh}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/bin/${file##./usr/bin/}
    else
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/${file}
    fi
  elif [[ ! "/${file##./usr/lib32}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/${file##./usr/lib32/}
  elif [[ ! "/${file##./usr/share/man/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
    gunzip $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
  elif [[ ! "/${file##./usr/share/pixmaps/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_datadir}/pixmaps/${file##./usr/share/pixmaps/}
  else
    echo ${file} found -- don\'t know how to handle
    exit 1
  fi
done
set -x

# Change perms on static libs. Can't fathom how to do it nicely above.
find $RPM_BUILD_ROOT/%{nvidialibdir} -type f -name "*.a" -exec chmod 0644 '{}' \;

# Fixme: should we do this directly in above for-loop? Yes, we should! No, please don't!
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so.1
ln -s libGL.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so
ln -s libGL.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-cfg.so.1
ln -s libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA.so
ln -s libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA_dynamic.so.1
ln -s libglx.so.%{version} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/extensions/nvidia/libglx.so

# 32-bit libs on x86_64
#%ifarch x86_64
#ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so
#ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so.1
#ln -s libGL.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGL.so.1 
#ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-tls.so.1
#ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/tls/libnvidia-tls.so.1
#ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-cfg.so.1
#%endif # x86_64

# profile.d files
install -D -p -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.sh
install -D -p -m 0755 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.csh

# modprobe.d file
install -D -p -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/nvidia-glx

# ld.so.conf.d file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/
echo "%{nvidialibdir}" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
#%ifarch x86_64
#echo "%{nvidialibdir32bit}" >> $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
#%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc nvidiapkg/usr/share/doc/*
%dir %{nvidialibdir}
%dir %{nvidialibdir}/tls
%dir %{_libdir}/xorg/modules/extensions/nvidia
#%{_initrddir}/nvidia-glx
%{nvidialibdir}/*.so.*
%{nvidialibdir}/tls/*.so.*
%{_sysconfdir}/profile.d/nvidia*
%{_libdir}/xorg/modules/drivers/nvidia_drv.so
%{_libdir}/xorg/modules/extensions/nvidia/*
%{_bindir}/*
#%{_datadir}/applications/*nvidia-settings.desktop
%{_datadir}/pixmaps/*.png
%config %{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%config %{_sysconfdir}/modprobe.d/nvidia-glx
#%{_mandir}/man[1-9]/nvidia*.*
%attr(0600,root,root) %dev(c,195,0) /dev/nvidia0
%attr(0600,root,root) %dev(c,195,1) /dev/nvidia1
%attr(0600,root,root) %dev(c,195,2) /dev/nvidia2
%attr(0600,root,root) %dev(c,195,3) /dev/nvidia3
%attr(0600,root,root) %dev(c,195,255) /dev/nvidiactl
%attr(0600,root,root) %dev(c,195,0) %{_sysconfdir}/udev/devices/nvidia0
%attr(0600,root,root) %dev(c,195,1) %{_sysconfdir}/udev/devices/nvidia1
%attr(0600,root,root) %dev(c,195,2) %{_sysconfdir}/udev/devices/nvidia2
%attr(0600,root,root) %dev(c,195,3) %{_sysconfdir}/udev/devices/nvidia3
%attr(0600,root,root) %dev(c,195,255) %{_sysconfdir}/udev/devices/nvidiactl


#%ifarch x86_64
#%files libs-32bit
#%dir %{nvidialibdir32bit}
#%dir %{nvidialibdir32bit}/tls
#%{nvidialibdir32bit}/*.so.*
#%{nvidialibdir32bit}/tls/*.so.*
#%endif  #x86_64


%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/nvidia
%dir %{_includedir}/nvidia/GL
%{_includedir}/nvidia/GL/*.h
%{nvidialibdir}/libXvMCNVIDIA.a
%{nvidialibdir}/*.so
#%ifarch x86_64
#%{nvidialibdir32bit}/*.so
#%endif #x86_64


%changelog
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.718608-1
- Version update
* Tue Nov 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.718607-1
- Version update
* Sat Jul 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.718606-1
- Version update
* Sun Feb 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.718604-1
- Version update
* Sun Sep 30 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.718601-1
- Version update
* Fri Sep 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.7185-1
- Version update
* Sat Sep 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.7184-3
- rebuilt against X.org 7.3
* Fri Jun 06 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.7184-2
- rebuilt against X.org 7.2
* Sat Jan 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.0.7184-1
- Initial Release 
